{% extends "/base/base.html" %} {% block title %}Administrar Instancias{%
endblock %} {% block content %}
<div class="container" id="table"></div>
<div class="section"></div>
<div id="modal1" class="modal modal-fixed-footer">
  <div class="modal-content">
    <h4>Nueva Contraseña</h4>
    <div class="row">
      <div class="input-field col s12">
        <input
          class="validate"
          type="password"
          name="password"
          id="input_password"
        />
        <label for="input_password">Contraseña</label>
      </div>
    </div>
  </div>
  <div class="modal-footer">
    <button
      type="button"
      class="modal-action btn btn-flat waves-effect blue darken-1"
      style="color: white;"
      onclick="guardarPasswd()"
    >
      Aceptar
    </button>
    <button
      type="button"
      class="btn btn-flat waves-effect red darken-1"
      style="color: white;"
      onclick="cerrarModal()"
    >
      Cancelar
    </button>
  </div>
</div>

<script>
  /*var cookieUser = document.cookie.slice(14);
  var arubaUser = "";
  var arubaPasswd = "";*/
  var vmid = [];

  function mostrarVM() {
    document.getElementById("table2").style.display = "none";
    $.ajax({
        method: "GET",
        url:
          "https://us-central1-tesismaniaas.cloudfunctions.net/mostrar_vm?user=" +
          arubaUser +
          "&passwd=" +
          arubaPasswd,
        success: function(data) {
          obj = jQuery.parseJSON(data);
          if(obj.length == 0){
            swal({
              title: "Error",
              text: "No existen VM's creadas",
              icon: "error",
              timer: 2000,
              buttons: false
            });
          }else{
            var content =
            '<div class="section"></div>' +
            '<h4 style="color: #2196f3">Instancias</h4>' +
            '<table class="centered responsive-table">';
          content +=
            "<thead>" +
            "<tr>" +
            "<th>ID</th>" +
            "<th>Nombre</th>" +
            "<th>Dirección IP</th>" +
            "<th>Estatus</th>" +
            "<th>Acciones</th>" +
            "</tr>" +
            "</thead>" +
            "<tbody>";
          for (i = 0; i < obj.length; i++) {
            vmid.push(obj[i]["vmid"]);
            if (obj[i]["status"] == 2) {
              circulo = '<div id="stat" class="container rojo"></div>';
            } else {
              circulo = '<div id="stat" class="container verde"></div>';
            }
            content +=
              "<tr><td>" +
              obj[i]["vmid"] +
              "</td>" +
              "<td>" +
              obj[i]["nombre"] +
              "</td>" +
              "<td>" +
              obj[i]["ipaddr"] +
              "</td>" +
              '<td id="statusCir">' +
              circulo +
              "</td>" +
              '<td id="spinner" style="display:none">' +
              '<div id="sele" class="preloader-wrapper big active">' +
              '<div class="spinner-layer" id="colo" color="red">' +
              '<div class="circle-clipper left">' +
              '<div class="circle"></div>' +
              '</div><div class="gap-patch">' +
              '<div class="circle"></div>' +
              '</div><div class="circle-clipper right">' +
              '<div class="circle"></div>' +
              "</div>" +
              "</div>" +
              "</div>" +
              "</td>" +
              '<td id="' +
              obj[i]["vmid"] +
              '">' +
              '<div class="input-field col s12">' +
              '<select id="selectAdministrar" class="icons" onchange="changeStatus(this.selectedIndex), changeColor(this.selectedIndex), mostrar(), abrirModal(this.selectedIndex)">' +
              '<option value="0" disabled selected>Selecciona una Acción</option>' +
              '<option value="1" data-icon="static/img/icons-01.png">Encender</option>' +
              '<option value="2" data-icon="static/img/icons-02.png">Apagar</option>' +
              '<option value="3" data-icon="static/img/icons-03.png">Restaurar</option>' +
              "</select>" +
              "</div>" +
              "</td>" +
              "</tr>";
          }
          content += "</tbody>" + "</table>";
          document.getElementById("table").style.display = "block";
          $("#table").html(content);
          $("select").formSelect();
          validarSelect();
          }
        }
      });
    /*$.when(
      console.log(arubaUser+" "+arubaPasswd)
      $.ajax({
        method: "GET",
        url:
          "https://us-central1-tesismaniaas.cloudfunctions.net/obtener_datos_aruba?usuario=" +
          cookieUser,
        success: function(data) {
          datos = jQuery.parseJSON(data);
          for (i = 0; i < datos.length; i++) {
            arubaUser = datos[i]["ac_user"];
            arubaPasswd = datos[i]["ac_passwd"];
          }
        }
      })
    ).done(function(){
      $.ajax({
        method: "GET",
        url:
          "https://us-central1-tesismaniaas.cloudfunctions.net/mostrar_vm?user=" +
          arubaUser +
          "&passwd=" +
          arubaPasswd,
        success: function(data) {
          obj = jQuery.parseJSON(data);
          if(obj.length == 0){
            swal({
              title: "Error",
              text: "No existen VM's creadas",
              icon: "error",
              timer: 2000,
              buttons: false
            });
          }else{
            var content =
            '<div class="section"></div>' +
            '<h4 style="color: #2196f3">Instancias</h4>' +
            '<table class="centered responsive-table">';
          content +=
            "<thead>" +
            "<tr>" +
            "<th>ID</th>" +
            "<th>Nombre</th>" +
            "<th>Dirección IP</th>" +
            "<th>Estatus</th>" +
            "<th>Acciones</th>" +
            "</tr>" +
            "</thead>" +
            "<tbody>";
          for (i = 0; i < obj.length; i++) {
            vmid.push(obj[i]["vmid"]);
            if (obj[i]["status"] == 2) {
              circulo = '<div id="stat" class="container rojo"></div>';
            } else {
              circulo = '<div id="stat" class="container verde"></div>';
            }
            content +=
              "<tr><td>" +
              obj[i]["vmid"] +
              "</td>" +
              "<td>" +
              obj[i]["nombre"] +
              "</td>" +
              "<td>" +
              obj[i]["ipaddr"] +
              "</td>" +
              '<td id="statusCir">' +
              circulo +
              "</td>" +
              '<td id="spinner" style="display:none">' +
              '<div id="sele" class="preloader-wrapper big active">' +
              '<div class="spinner-layer" id="colo" color="red">' +
              '<div class="circle-clipper left">' +
              '<div class="circle"></div>' +
              '</div><div class="gap-patch">' +
              '<div class="circle"></div>' +
              '</div><div class="circle-clipper right">' +
              '<div class="circle"></div>' +
              "</div>" +
              "</div>" +
              "</div>" +
              "</td>" +
              '<td id="' +
              obj[i]["vmid"] +
              '">' +
              '<div class="input-field col s12">' +
              '<select id="selectAdministrar" class="icons" onchange="changeStatus(this.selectedIndex), changeColor(this.selectedIndex), mostrar(), abrirModal(this.selectedIndex)">' +
              '<option value="0" disabled selected>Selecciona una Acción</option>' +
              '<option value="1" data-icon="static/img/icons-01.png">Encender</option>' +
              '<option value="2" data-icon="static/img/icons-02.png">Apagar</option>' +
              '<option value="3" data-icon="static/img/icons-03.png">Restaurar</option>' +
              "</select>" +
              "</div>" +
              "</td>" +
              "</tr>";
          }
          content += "</tbody>" + "</table>";
          document.getElementById("table").style.display = "block";
          $("#table").html(content);
          $("select").formSelect();
          validarSelect();
          }
        }
      });
    });*/
  }
</script>

<script>
  var nombreServidor = "";
  var newPasswd = "";

  function changeColor(newColor) {
    if (newColor == 1) {
      $("#colo").removeClass();
      $("#colo").addClass("spinner-layer spinner-green-only");
    } else if (newColor == 2) {
      $("#colo").removeClass();
      $("#colo").addClass("spinner-layer spinner-red-only");
    } else if (newColor == 3) {
      $("#colo").removeClass();
      $("#colo").addClass("spinner-layer spinner-blue-only");
    }
  }

  function ocultar(estatus) {
    if (estatus == 2) {
      $("#stat").removeClass();
      $("#stat").addClass("container rojo");
    } else if (estatus == 3) {
      $("#stat").removeClass();
      $("#stat").addClass("container verde");
    }
    document.getElementById("statusCir").style.display = "table-cell";
    document.getElementById("spinner").style.display = "none";
  }

  function mostrar() {
    document.getElementById("spinner").style.display = "block";
    document.getElementById("statusCir").style.display = "none";
  }

  function validarSelect() {
    $.ajax({
      method: "GET",
      url:
        "https://us-central1-tesismaniaas.cloudfunctions.net/obtener_datos_vm?user=" +
        arubaUser +
        "&passwd=" +
        arubaPasswd,
      success: function(data) {
        obj = jQuery.parseJSON(data);
        for (i = 0; i < obj.length; i++) {
          if (obj[i]["status"] == 2 && obj[i]["vmid"] == vmid[i]) {
            li = $("li", "#" + vmid[i])
              .eq(1)
              .removeClass("disabled");
            li = $("li", "#" + vmid[i])
              .eq(2)
              .addClass("disabled");
          } else if (obj[i]["status"] == 3 && obj[i]["vmid"] == vmid[i]) {
            li = $("li", "#" + vmid[i])
              .eq(2)
              .removeClass("disabled");
            li = $("li", "#" + vmid[i])
              .eq(1)
              .addClass("disabled");
          }
        }
      }
    });
  }

  function obtenerNombreServidor() {
    $.ajax({
      method: "GET",
      url:
        "https://us-central1-tesismaniaas.cloudfunctions.net/obtener_datos_vm?user=" +
        arubaUser +
        "&passwd=" +
        arubaPasswd,
      success: function(data) {
        obj = jQuery.parseJSON(data);
        for (i = 0; i < obj.length; i++) {
          if (obj[i]["vmid"] == vmid[i]) {
            nombreServidor = obj[i]["nombre"];
          }
        }
      }
    });
  }

  function abrirModal(selectID) {
    if (selectID == 3) {
      $("#modal1").modal("open");
    }
  }

  function guardarPasswd() {
    newPasswd = document.getElementById("input_password").value;
    $.when(obtenerNombreServidor()).done(function(){
      setTimeout(function() {
        $.ajax({
          method: "POST",
          url:
            "https://us-central1-tesismaniaas.cloudfunctions.net/restaurar_servidor?user=" +
            arubaUser +
            "&passwd=" +
            arubaPasswd +
            "&server-name=" +
            nombreServidor +
            "&new-passwd=" +
            newPasswd,
          success: function(data) {
            $("#modal1").modal("close");
            $("#selectAdministrar").val("0");
            $("#selectAdministrar").formSelect();
          }
        });
        setTimeout(() => obtenerStatus(3), 30000);
      }, 5000);
    });
  }

  function cerrarModal() {
    $.when(obtenerNombreServidor()).done(function(){
      $.ajax({
        method: "GET",
        url:
          "https://us-central1-tesismaniaas.cloudfunctions.net/obtener_estatus?user=" +
          arubaUser +
          "&passwd=" +
          arubaPasswd +
          "&server-name=" +
          nombreServidor,
        success: function(data) {
          ocultar(data);
          $("#modal1").modal("close");
          $("#selectAdministrar").val("0");
          $("#selectAdministrar").formSelect();
        }
      });
    });
  }

  function obtenerStatus(administra) {
    $.when(obtenerNombreServidor()).done(function(){
      $.ajax({
        method: "GET",
        url:
          "https://us-central1-tesismaniaas.cloudfunctions.net/obtener_estatus?user=" +
          arubaUser +
          "&passwd=" +
          arubaPasswd +
          "&server-name=" +
          nombreServidor,
        success: function(data) {
          compararEstatus(data, administra);
        }
      });
    });
  }

  function compararEstatus(estatus, administra) {
    estatusFinal = estatus;

    if (administra == 1) {
      if (estatusFinal == 2) {
        setTimeout(() => obtenerStatus(administra), 10000);
      } else if (estatusFinal == 3) {
        ocultar(estatusFinal);
        swal({
          title: "Servidor encendido",
          text: "El servidor se encendió correctamente",
          icon: "success",
          timer: 2000,
          buttons: false
        });
        validarSelect();
      }
    } else if (administra == 2) {
      if (estatusFinal == 3) {
        setTimeout(() => obtenerStatus(administra), 10000);
      } else if (estatusFinal == 2) {
        ocultar(estatusFinal);
        swal({
          title: "Servidor apagado",
          text: "El servidor se apagó correctamente",
          icon: "success",
          timer: 2000,
          buttons: false
        });
        validarSelect();
      }
    } else if (administra == 3) {
      if (estatusFinal == 2) {
        setTimeout(() => obtenerStatus(administra), 10000);
      } else if (estatusFinal == 3) {
        ocultar(estatusFinal);
        swal({
          title: "Servidor restaurado",
          text: "El servidor se restauró correctamente",
          icon: "success",
          timer: 2000,
          buttons: false
        });
      }
    }
  }

  function changeStatus(status) {
    $.when(obtenerNombreServidor()).done(function(){
      if (status == 1) {
      setTimeout(function() {
        $.ajax({
          method: "POST",
          url:
            "https://us-central1-tesismaniaas.cloudfunctions.net/encender_servidor?user=" +
            arubaUser +
            "&passwd=" +
            arubaPasswd +
            "&server-name=" +
            nombreServidor,
          success: function(data) {
            $("#selectAdministrar").val("0");
            $("#selectAdministrar").formSelect();
          }
        });
        setTimeout(() => obtenerStatus(1), 10000);
      }, 5000);
    } else if (status == 2) {
      setTimeout(function() {
        $.ajax({
          method: "POST",
          url:
            "https://us-central1-tesismaniaas.cloudfunctions.net/apagar_servidor?user=" +
            arubaUser +
            "&passwd=" +
            arubaPasswd +
            "&nombre=" +
            nombreServidor,
          success: function(data) {
            $("#selectAdministrar").val("0");
            $("#selectAdministrar").formSelect();
          }
        });
        setTimeout(() => obtenerStatus(2), 10000);
      }, 5000);
    } else if (status == 3) {
      abrirModal(status);
    }
    }); 
  }
</script>

<script type="text/javascript">
  $(document).ready(function() {
    $(".modal").modal({
      dismissible: false,
      opacity: 0.5,
      in_duration: 300,
      out_duration: 200
    });
  });
</script>

<div class="container" style="width: 30%;" id="table2"></div>
<div id="modal2" class="modal modal-fixed-footer">
  <div class="modal-content">
    <h6>Selecciona la instancia a la que se le instalarán las dependencias</h6>
    <ul class="stepper linear">
      <li class="step active">
        <div class="step-title waves-effect">Hosts</div>
        <div id="stepHost" class="step-content">
          
        </div>
      </li>
      <li class="step">
        <div class="step-title waves-effect">Passwords</div>
        <div id="stepPasswords" class="step-content">
          <div class="row">
            <div class="input-field col s12">
              <input
                class="validate"
                type="text"
                name="sshUser"
                id="input_sshUser"
                required
              />
              <label for="input_sshUser">SSH User</label>
            </div>
            <div class="input-field col s12">
              <input
                class="validate"
                type="password"
                name="sshPass"
                id="input_sshPass"
                required
              />
              <label for="input_sshPass">SSH Password</label>
            </div>
            <div class="input-field col s12">
              <input
                class="validate"
                type="password"
                name="sudoPass"
                id="input_sudoPass"
                required
              />
              <label for="input_sudoPass">User Sudo Password</label>
            </div>
          </div>
          <div class="step-actions">
             <button
              class="waves-effect waves-dark btn-flat previous-step"
             >
              Regresar
            </button>
          </div>
        </div>
        </div>
      </li>
    </ul>

    
  <div class="modal-footer">
    <button
      id="btnPlaybook"
      type="button"
      class="btn btn-flat waves-effect blue darken-1"
      style="color: white;"
      onclick="guardarHost()"
    >
      Aplicar Playbook
    </button>
    <button
      type="button"
      class="btn btn-flat waves-effect red darken-1"
      style="color: white;"
      onclick="cerrarModalHosts()"
    >
      Cerrar
    </button>
  </div>
</div>

<script type="text/javascript">
  
  function mostrarPlaybooks() {
    document.getElementById("table").style.display = "none";
    document.getElementById("table2").style.display = "block";
    
      '{% if subdirs |length ==0 %}'
          swal({
          icon: "error",
          text: "No existen playbooks disponibles",
          timer: 2000,
          buttons: false
        });
      '{% else %}'
          var content = 
          '<div class="section"></div>' +
          '<h4 style="color: #2196f3">Dependencias</h4>' +
          '<table class="centered">' +
          "<tbody>" +
          "{% for dirs in subdirs %}" +
          "<tr>" +
          "<td>" +
          "<label>" +
          '<input name="checks[]" type="checkbox" value="{{ dirs }}"/>' +
          "<span></span>" +
          "</label>" +
          "</td>" +
          "<td>{{ dirs }}</td>" +
          "</tr>" +
          "{% endfor %}" +
          "</tbody>" +
          "</table>" +
          "<br>" +
          '<button id="btnPlaybooks" type="button" class="btn btn-flat waves-effect blue darken-1" style="color: white;" onclick="guardarPlaybooks()">Seleccionar Instancia</button>';
          $("#table2").html(content);
      '{% endif %}'
      
  }
  
  function guardarPlaybooks() {
    var arrayPb = $('[name="checks[]"]:checked')
      .map(function() {
        return this.value;
      })
      .get();

    jsonPB = JSON.stringify(arrayPb);
    if (arrayPb == "") {
      swal({
        icon: "error",
        text: "No se seleccionó ningún playbook",
        timer: 2000,
        buttons: false
      });
    } else {
      $.ajax({
        url: "/creaPB",
        type: "POST",
        contentType: "application/json",
        data: jsonPB,
        success: function(data) {
          swal({
            title: "Playbook Creado",
            icon: "success",
            timer: 1500,
            buttons: false
          });
        }
      });
      $.when(
          $.ajax({
            method: "GET",
            url:
              "https://us-central1-tesismaniaas.cloudfunctions.net/obtener_datos_vm?user=" +
              arubaUser +
              "&passwd=" +
              arubaPasswd,
            success: function(data) {
              obj = jQuery.parseJSON(data);
              for (i = 0; i < obj.length; i++) {
                nombreServidor = obj[i]["nombre"];
                ipServidor = obj[i]["ip"]
                var contentModal = '<p>'+
                                      '<label>'+
                                        '<input class="with-gap" name="group1" type="radio" value='+ipServidor+' onclick="mostrarBtn()"/>'+
                                        '<span>'+nombreServidor+'</span>'+
                                      '</label>'+
                                    '</p>';
              }
              contentModal += '<div class="step-actions">'+
                                '<button id="stepContinue" class="waves-effect waves-dark btn blue next-step" data-feedback="validaCampos" style="color: white;">Continuar</button>'+
                              '</div>';
              $("#stepHost").html(contentModal);
              stepperDiv = document.querySelector(".stepper");
              stepper = new MStepper(stepperDiv, {
                firstActive: 0,
                stepTitleNavigation: false
              });
              stepper.resetStepper();
              document.getElementById("stepHost").style.display= "block";
              $("#stepContinue").hide();
              $("#btnPlaybook").hide();
            }
          })
        ).done(function(){
          $("#modal2").modal("open");
        });
      /*var cookieUser = document.cookie.slice(14);
      var arubaUser = "";
      var arubaPasswd = "";

      $.when(
        $.ajax({
          method: "GET",
          url:
            "https://us-central1-tesismaniaas.cloudfunctions.net/obtener_datos_aruba?usuario=" +
            cookieUser,
            success: function(data) {
            datos = jQuery.parseJSON(data);
            for (i = 0; i < datos.length; i++) {
              arubaUser = datos[i]["ac_user"];
              arubaPasswd = datos[i]["ac_passwd"];
            }
          }
        })
      ).done(function(){
        $.when(
          $.ajax({
            method: "GET",
            url:
              "https://us-central1-tesismaniaas.cloudfunctions.net/obtener_datos_vm?user=" +
              arubaUser +
              "&passwd=" +
              arubaPasswd,
            success: function(data) {
              obj = jQuery.parseJSON(data);
              for (i = 0; i < obj.length; i++) {
                nombreServidor = obj[i]["nombre"];
                ipServidor = obj[i]["ip"]
                var contentModal = '<p>'+
                                      '<label>'+
                                        '<input class="with-gap" name="group1" type="radio" value='+ipServidor+' onclick="mostrarBtn()"/>'+
                                        '<span>'+nombreServidor+'</span>'+
                                      '</label>'+
                                    '</p>';
              }
              contentModal += '<div class="step-actions">'+
                                '<button id="stepContinue" class="waves-effect waves-dark btn blue next-step" data-feedback="validaCampos" style="color: white;">Continuar</button>'+
                              '</div>';
              $("#stepHost").html(contentModal);
              var stepperDiv = document.querySelector('.stepper');
              var stepper = new MStepper(stepperDiv,{
                firstActive: 0,
                stepTitleNavigation: false
              });
              stepper.resetStepper();
              document.getElementById("stepHost").style.display= "block";
              $("#stepContinue").hide();
              $("#btnPlaybook").hide();
            }
          })
        ).done(function(){
          $("#modal2").modal("open");
        });
      });*/
    }
  }
  
  function mostrarBtn(){
    $("#stepContinue").show();
  }

  function validaCampos(destroyFeedback) {
    $("#btnPlaybook").show();
    var radios = document.getElementsByName('group1');
    for (var i = 0, length = radios.length; i < length; i++) {
      if (radios[i].checked) {
        document.getElementById("stepPasswords").style.display= "block";
        break;
      }
    }
    destroyFeedback(true);
  }

  function guardarHost() {
    var radios = document.getElementsByName('group1');
    var host;
    var sshUser = document.getElementById("input_sshUser").value;
    var sshPass = document.getElementById("input_sshPass").value;
    var sudoPass = document.getElementById("input_sudoPass").value;
    for (var i = 0, length = radios.length; i < length; i++) {
      if (radios[i].checked) {
        document.getElementById("stepPasswords").style.display= "block";
        host = radios[i].value;
        break;
      }
    }
    if(sshUser == "" || sshPass == "" || sudoPass == ""){
        swal({
          icon: "error",
          title: "Campos vacíos",
          text: "Favor de llenar todos los campos",
          timer: 3000,
          buttons: false
        });
    }else{
      $.when(
        $.ajax({
          method: "POST",
          url:
            "/crearHost?host=" +
            host +
            "&sshUser=" +
            sshUser +
            "&sshPass=" +
            sshPass +
            "&sudoPass=" +
            sudoPass,
          contentType: "application/json",
          success: function(data) {
            $("#modal2").modal("close");
            document.getElementById("input_sshUser").value = "";
            document.getElementById("input_sshPass").value = "";
            document.getElementById("input_sudoPass").value = "";
            stepperDiv = document.querySelector(".stepper");
            stepper = new MStepper(stepperDiv, {
              firstActive: 0,
              stepTitleNavigation: false
              });
            stepper.resetStepper();
          }
        })
      ).done(function(){
        setTimeout(function() {
          $.ajax({
            url: "/aplicaPB",
            success: function(data) {
              if(data == "True"){
                swal({
                  title: "Dependencias instaladas",
                  text: "Dependencias instaladas correctamente",
                  icon: "success",
                  timer: 4000,
                  buttons: false
                });
              }else if(data == "False"){
                swal({
                  title: "Error",
                  text: "No se pudo establecer la conexión con el host",
                  icon: "error",
                  timer: 4000,
                  buttons: false
                });
              }else{
                swal({
                  title: "Error",
                  text: "Dependencias no instaladas",
                  icon: "error",
                  timer: 4000,
                  buttons: false
                });
              }
            }
          });
        }, 500);
      });
    }
  }
  function cerrarModalHosts() {
    document.getElementById("input_sshUser").value = "";
    document.getElementById("input_sshPass").value = "";
    document.getElementById("input_sudoPass").value = "";
    $("#modal2").modal("close");
    stepperDiv = document.querySelector(".stepper");
    stepper = new MStepper(stepperDiv, {
       firstActive: 0,
       stepTitleNavigation: false
      });
    stepper.resetStepper();
  }
</script>

{% endblock content %}
